
#ifndef VKTabulatedField3D_h
#define VKTabulatedField3D_h 1

#include "globals.hh"
#include "G4MagneticField.hh"
#include "G4ios.hh"
#include "G4SystemOfUnits.hh"

#include <fstream>
#include <vector>
#include <cmath>


class G4GenericMessenger;


class VKTabulatedField3D : public G4MagneticField
{  
    public:
        VKTabulatedField3D (const char* filename, G4double maxBField);
        virtual ~VKTabulatedField3D();

        // get methods        
        void GetFieldValue (const double Point[4], double *Bfield) const;
        inline G4double GetMaxFieldValue () const { return fBMax; }

        // set methods
        void SetMaxFieldValue (G4double bmax);

    private:
        G4double fBMax0, fBMax;       
        // Storage space for the table
        std::vector< std::vector< std::vector< double > > > xField;
        std::vector< std::vector< std::vector< double > > > yField;
        std::vector< std::vector< std::vector< double > > > zField;
        // The dimensions of the table
        int nx,ny,nz; 
        // The physical limits of the defined region
        double minx, maxx, miny, maxy, minz, maxz;
        // The physical extent of the defined region
        double dx, dy, dz;
        bool invertX, invertY, invertZ;
};

#endif
